#include "stdafx.h"

#include "TouchPanel.h"

/* Defines */
#define TOUCHPANEL_REGKEY_NAME			_T("HARDWARE\\DEVICEMAP\\TOUCH")
#define TOUCHPANEL_DISABLE_VALUE_NAME	_T("Disable")
#define TOUCHPANEL_UPDATE_EVENT			_T("TouchUpdateMode")


void
TP_EnableTouchPanel(
	BOOL	bEnable
)
{
	LONG	lResult = 0;
	HKEY	hKey	= NULL;


	lResult = RegOpenKeyEx(HKEY_LOCAL_MACHINE, TOUCHPANEL_REGKEY_NAME, 0, 0, &hKey);
	if (lResult == ERROR_SUCCESS) {
		DWORD	dwData;
		DWORD	dwType;
		DWORD	dwSize;

		if (bEnable) {
			dwData = 0;
		}
		else {
			dwData = 1;
		}
		dwSize = sizeof(dwData);
		dwType = REG_DWORD;

		lResult = RegSetValueEx(hKey, TOUCHPANEL_DISABLE_VALUE_NAME, NULL, dwType, (LPBYTE)&dwData, dwSize);
		if (lResult == ERROR_SUCCESS) {
			HANDLE	hEvent = NULL;

			hEvent = CreateEvent(NULL, FALSE, FALSE, TOUCHPANEL_UPDATE_EVENT);
			if (hEvent != NULL) {
				SetEvent(hEvent);
				CloseHandle(hEvent);
				hEvent = NULL;
			}
		}

		RegCloseKey(hKey);
		hKey = NULL;
	}

}


BOOL
TP_IsTouchPanelEnable()
{
	BOOL	bRet = FALSE;
	HKEY	hKey = FALSE;
	LONG	lResult = 0;

	bRet = TRUE;	// default return value

	lResult = RegOpenKeyEx(HKEY_LOCAL_MACHINE, TOUCHPANEL_REGKEY_NAME, 0, 0, &hKey);
	if (lResult == ERROR_SUCCESS) {
		DWORD	dwType;
		DWORD	dwData;
		DWORD	dwSize;

		dwSize = sizeof(dwData);

		lResult = RegQueryValueEx(hKey, TOUCHPANEL_DISABLE_VALUE_NAME, NULL, &dwType, (LPBYTE)&dwData, &dwSize);

		if (lResult == ERROR_SUCCESS) {
			if (dwData) {
				// Disable
				bRet = FALSE;
			}
			else {
				// Enable
				bRet = TRUE;
			}
		}
		RegCloseKey(hKey);
		hKey = NULL;
	}

	return bRet;
}