// 03KeyLockUtil.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include "03KeyLockComm.h"

#define	WZERO3_KEYLOCK_UTIL_MUTEX_NAME		_T("03KEYLOCK_UTIL_MUTEX")

#define	WZERO3_KEYLOCK_UTIL_OPTION_ON		_T("on")
#define	WZERO3_KEYLOCK_UTIL_OPTION_OFF		_T("off")
#define	WZERO3_KEYLOCK_UTIL_OPTION_STOP		_T("stop")
#define	WZERO3_KEYLOCK_UTIL_OPTION_RELOAD	_T("reload")
#define	WZERO3_KEYLOCK_UTIL_OPTION_TICK		_T("tick")

static
void
ControlLocker(
	UINT	message,
	WPARAM	wParam,
	LPARAM	lParam
)
{
	HWND	hWnd;

	hWnd = FindWindow(WZERO3_KEYLOCK_WINDOW_CLASS_NAME, WZERO3_KEYLOCK_WINDOW_TITLE_NAME);
	if (hWnd != NULL) {
		PostMessage(hWnd, message, wParam, lParam);
	}
}

int
WINAPI
WinMain(
	HINSTANCE hInstance,
	HINSTANCE hPrevInstance,
	LPTSTR    lpCmdLine,
	int       nCmdShow
)
{
	HANDLE	hMutex = NULL;

	// dN`FbN
	hMutex = CreateMutex(NULL, TRUE, WZERO3_KEYLOCK_UTIL_MUTEX_NAME);
	if (hMutex != NULL) {
		if (GetLastError() == ERROR_ALREADY_EXISTS) {

			CloseHandle(hMutex);
			hMutex = NULL;
			return FALSE;
		}
	}
	else {
		return FALSE;
	}
	//

	if (lpCmdLine != NULL && _tcscmp(lpCmdLine, WZERO3_KEYLOCK_UTIL_OPTION_ON) == 0) {
		ControlLocker(WM_USER_KEYLOCK_CONTROL, KEYLOCK_CONTROL_ON, 0);
	}
	else if (lpCmdLine != NULL && _tcscmp(lpCmdLine, WZERO3_KEYLOCK_UTIL_OPTION_OFF) == 0) {
		ControlLocker(WM_USER_KEYLOCK_CONTROL, KEYLOCK_CONTROL_OFF, 0);
	}
	else if (lpCmdLine != NULL && _tcscmp(lpCmdLine, WZERO3_KEYLOCK_UTIL_OPTION_RELOAD) == 0) {
		ControlLocker(WM_USER_RELOAD_SETTING, 0, 0);
	}
	else if (lpCmdLine != NULL && _tcscmp(lpCmdLine, WZERO3_KEYLOCK_UTIL_OPTION_TICK) == 0) {
		ControlLocker(WM_USER_TICK, 0, 0);
	}
	else if (lpCmdLine != NULL && _tcscmp(lpCmdLine, WZERO3_KEYLOCK_UTIL_OPTION_STOP) == 0) {
		ControlLocker(WM_CLOSE, 0, 0);
	}
	else {
		ControlLocker(WM_USER_KEYLOCK_CONTROL, KEYLOCK_CONTROL_TOGGLE, 0);
	}

	ReleaseMutex(hMutex);
	CloseHandle(hMutex);
	hMutex = NULL;
	return 0;
}

